# WEB+DB Press 113「Ruby書き方ドリル」サンプルコード
Version: 2019-10-24

著者: 澤田剛 (sawa)

　このディレクトリに収録したファイルは、WEB+DB Press 113号の第2特集記事「Ruby書き方ドリル」の記事中の回答コードとそのテストを含んでいます。次のファイルがあります。

* `README.md`: このファイル。使い方の説明
* `LICENSE.txt`: ライセンス
* `answers/exercise_XX.rb`: 特集記事の例題XXの回答中のコード
* `tests/test_exercise_XX.rb`: 例題XXの回答中のコードのテストコード
* `tests/test_all.rb`: 上記の全てのテストファイルを一括して実行するコード
* `lib/test_helper.rb`: オリジナルの簡単なテストフレームワーク

## 依存ライブラリ

　テストは、次のgemに依存します。これらをインストールしなくても問題ありませんが、一部の機能が実行されません。

* `method_source`: テスト結果にテスト対象のコードのソースを表示するのに使います。
* `benchmark/ips`: ベンチマークを実行し、別解を比較するのに使います。

## 使用法

　個別の例題のテストを実行するには、次のようにします。

    $ ruby tests/test_exercise_XX.rb

　すべての例題のテストを一括して実行するには、次のようにします。

    $ ruby tests/test_all.rb

## 表記法

　回答を追加するには、

* `answers/exercise_XX.rb`ファイルに`AnswerY`のようなモジュールを作り、その中で、実行すべきコードをメソッド定義文`def code`...`end`の中に書く。
* `tests/test_exercise_XX.rb`ファイルの`Test.suite`コマンドのキーワード引数`answers`の値の配列の中に`AnswerY`を追加する。

## テスト

　回答には、記事中で示したように、間違った値を返すものや、意図された、あるいはされていないエラーを発生するものがあります。実行結果の後には、次の表示を付けます。

* `# =>`: 戻り値
* `# >>`: 標準出力
* `# !>`: エラー

## ベンチマーク

　ベンチマークは、エラーを発生することが意図されていない例題について、意図どおりの値を返し大きく時間が掛からない回答が複数ある場合に行われます。
